/*
 * This file was generated automatically by ExtUtils::ParseXS version 3.16 from the
 * contents of Request.xs. Do not edit this file, edit Request.xs instead.
 *
 *    ANY CHANGES MADE HERE WILL BE LOST!
 *
 */

#line 1 "Request.xs"
/* Copyright 2000-2004  The Apache Software Foundation
**
** Licensed under the Apache License, Version 2.0 (the "License");
** you may not use this file except in compliance with the License.
** You may obtain a copy of the License at
**
**     http://www.apache.org/licenses/LICENSE-2.0
**
** Unless required by applicable law or agreed to in writing, software
** distributed under the License is distributed on an "AS IS" BASIS,
** WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
** See the License for the specific language governing permissions and
** limitations under the License.
*/

#define PERL_NO_GET_CONTEXT     /* we want efficiency */

#ifdef WIN32

#ifdef uid_t
#define apache_uid_t uid_t
#undef uid_t
#endif
#define uid_t apache_uid_t

#ifdef gid_t
#define apache_gid_t gid_t
#undef gid_t
#endif
#define gid_t apache_gid_t

#ifdef stat
#define apache_stat stat
#undef stat
#endif

#ifdef lstat
#define apache_lstat lstat
#undef lstat
#endif

#ifdef isnan
#define apache_isnan isnan
#undef isnan
#endif

#ifdef sleep
#define apache_sleep sleep
#undef sleep
#endif

#endif /* WIN32 */

#undef __attribute__
#include "mod_perl.h"
#include "apache_request.h"
#include "patchlevel.h"

#ifdef WIN32

#undef uid_t
#ifdef apache_uid_t
#define uid_t apache_uid_t
#undef apache_uid_t
#endif

#undef gid_t
#ifdef apache_gid_t
#define gid_t apache_gid_t
#undef apache_gid_t
#endif

#ifdef apache_isnan
#undef isnan
#define isnan apache_isnan
#undef apache_isnan
#endif

#ifdef apache_lstat
#undef lstat
#define lstat apache_lstat
#undef apache_lstat
#endif

#ifdef apache_stat
#undef stat
#define stat apache_stat
#undef apache_stat
#endif

#ifdef apache_sleep
#undef sleep
#define sleep apache_sleep
#undef apache_sleep
#endif

#endif /* WIN32 */

typedef ApacheRequest * Apache__Request;
typedef ApacheUpload  * Apache__Upload;

typedef struct {
    SV *data;
    SV *sub;
    PerlInterpreter *perl;
} UploadHook;

#define XsUploadHook       ((UploadHook *)RETVAL->hook_data)
#define XsUploadHookNew(p) (void *)ap_pcalloc(p, sizeof(UploadHook))

#ifdef USE_ITHREADS
#define XsUploadHookNew_perl XsUploadHook->perl = aTHX
#else
#define XsUploadHookNew_perl 
#endif

#define XsUploadHookSet(slot, sv) \
     if (RETVAL->hook_data) { \
         if (XsUploadHook->slot) { \
             SvREFCNT_dec(XsUploadHook->slot); \
         } \
     } \
     else { \
         RETVAL->hook_data = XsUploadHookNew(r->pool); \
         XsUploadHookNew_perl; \
         ap_register_cleanup(r->pool, (void*)XsUploadHook, \
                             upload_hook_cleanup, ap_null_cleanup); \
     } \
     XsUploadHook->slot = SvREFCNT_inc(sv)

#define ApacheUpload_fh(upload)       upload->fp
#define ApacheUpload_name(upload)     upload->name
#define ApacheUpload_filename(upload) upload->filename
#define ApacheUpload_next(upload)     upload->next
#define ApacheUpload_tempname(upload) upload->tempname

#ifdef PerlIO
typedef PerlIO * ApreqInputStream;

/* XXX: or should this be #ifdef PERL_IMPLICIT_SYS ? */
#ifdef WIN32
#   ifndef PerlIO_importFILE
#      define PerlIO_importFILE(fp,flags)	(PerlIO*)fp
#   endif
#endif

#ifdef SFIO
#undef PerlIO_importFILE
#define PerlIO_importFILE(fp,flags) 	(PerlIO*)fp
#endif /*SFIO*/

#else /*PerlIO not defined*/

typedef FILE * ApreqInputStream;
#define PerlIO_importFILE(fp,flags) 	fp
#define PerlIO_write(a,b,c)  		fwrite((b),1,(c),(a))

#endif /*PerlIO*/

static char *r_keys[] = { "_r", "r", NULL };

static SV *r_key_sv(pTHX_ SV *in)
{
    SV *sv;
    int i;

    for (i=0; r_keys[i]; i++) {
	int klen = strlen(r_keys[i]);
	if(hv_exists((HV*)SvRV(in), r_keys[i], klen) &&
	   (sv = *hv_fetch((HV*)SvRV(in), 
			   r_keys[i], klen, FALSE)))
	{
	    return sv;
	}
    }

    return Nullsv;
}

static ApacheRequest *sv_2apreq(pTHX_ SV *sv)
{
    if (SvROK(sv) && sv_derived_from(sv, "Apache::Request")) { 
	SV *obj = sv;

	switch (SvTYPE(SvRV(obj))) {
	case SVt_PVHV :
            do {
                obj = r_key_sv(aTHX_ obj);
            } while (SvROK(obj) && (SvTYPE(SvRV(obj)) == SVt_PVHV));
	    break;
	default:
	    break;
	};
	return (ApacheRequest *)SvIV((SV*)SvRV(obj)); 
    }
    else {
	return ApacheRequest_new(perl_request_rec(NULL));
    }
} 

static SV *upload_bless(pTHX_ ApacheUpload *upload) 
{ 
    SV *sv = newSV(0);  
    sv_setref_pv(sv, "Apache::Upload", (void*)upload);  
    return sv; 
} 

static int upload_hook(void *ptr, char *buf, int len, ApacheUpload *upload)
{
    UploadHook *hook = (UploadHook *)ptr;
#ifdef USE_ITHREADS
    dTHXa(hook->perl);
#endif
    
    if (!(upload->fp || ApacheRequest_tmpfile(upload->req, upload)))
        return -1; /* error */

    {
    	SV *sv;
    	dSP;

    	PUSHMARK(SP);
    	EXTEND(SP, 4);
        ENTER;
    	SAVETMPS;

    	sv = sv_newmortal();
    	sv_setref_pv(sv, "Apache::Upload", (void*)upload);
    	PUSHs(sv);

    	sv = sv_2mortal(newSVpvn(buf,len));
    	SvTAINT(sv);
    	PUSHs(sv);

    	sv = sv_2mortal(newSViv(len));
    	SvTAINT(sv);
    	PUSHs(sv);

    	PUSHs(hook->data);

    	PUTBACK;
    	perl_call_sv(hook->sub, G_EVAL|G_DISCARD);
    	FREETMPS;
    	LEAVE;
    }

    if (SvTRUE(ERRSV))
        return -1;

    return fwrite(buf, 1, len, upload->fp);
}

static void upload_hook_cleanup(void *ptr)
{
    UploadHook *hook = (UploadHook *)ptr;
#ifdef USE_ITHREADS
    dTHXa(hook->perl);
#endif
    
    if (hook->sub) {
        SvREFCNT_dec(hook->sub);
        hook->sub = Nullsv;
    }
    if (hook->data) {
        SvREFCNT_dec(hook->data);
        hook->data = Nullsv;
    }
}

#define upload_push(upload) \
    XPUSHs(sv_2mortal(upload_bless(upload))) 

static void apreq_add_magic(pTHX_ SV *sv, SV *obj, ApacheRequest *req)
{
    sv_magic(SvRV(sv), obj, '~', "dummy", -1);
    SvMAGIC(SvRV(sv))->mg_ptr = (char *)req->r;
}

#ifdef CGI_COMPAT
static void register_uploads (pTHX_ ApacheRequest *req) {
    ApacheUpload *upload;

    for (upload = req->upload; upload; upload = upload->next) {
	if(upload->fp && upload->filename) {
	    GV *gv = gv_fetchpv(upload->filename, TRUE, SVt_PVIO);
	    if (do_open(gv, "<&", 2, FALSE, 0, 0, upload->fp)) { 
		ap_register_cleanup(req->r->pool, (void*)gv, 
				    apreq_close_handle, ap_null_cleanup);
	    } 
	}
    }
}
#else
#define register_uploads(req)
#endif

#line 307 "Request.c"
#ifndef PERL_UNUSED_VAR
#  define PERL_UNUSED_VAR(var) if (0) var = var
#endif

#ifndef dVAR
#  define dVAR		dNOOP
#endif


/* This stuff is not part of the API! You have been warned. */
#ifndef PERL_VERSION_DECIMAL
#  define PERL_VERSION_DECIMAL(r,v,s) (r*1000000 + v*1000 + s)
#endif
#ifndef PERL_DECIMAL_VERSION
#  define PERL_DECIMAL_VERSION \
	  PERL_VERSION_DECIMAL(PERL_REVISION,PERL_VERSION,PERL_SUBVERSION)
#endif
#ifndef PERL_VERSION_GE
#  define PERL_VERSION_GE(r,v,s) \
	  (PERL_DECIMAL_VERSION >= PERL_VERSION_DECIMAL(r,v,s))
#endif
#ifndef PERL_VERSION_LE
#  define PERL_VERSION_LE(r,v,s) \
	  (PERL_DECIMAL_VERSION <= PERL_VERSION_DECIMAL(r,v,s))
#endif

/* XS_INTERNAL is the explicit static-linkage variant of the default
 * XS macro.
 *
 * XS_EXTERNAL is the same as XS_INTERNAL except it does not include
 * "STATIC", ie. it exports XSUB symbols. You probably don't want that
 * for anything but the BOOT XSUB.
 *
 * See XSUB.h in core!
 */


/* TODO: This might be compatible further back than 5.10.0. */
#if PERL_VERSION_GE(5, 10, 0) && PERL_VERSION_LE(5, 15, 1)
#  undef XS_EXTERNAL
#  undef XS_INTERNAL
#  if defined(__CYGWIN__) && defined(USE_DYNAMIC_LOADING)
#    define XS_EXTERNAL(name) __declspec(dllexport) XSPROTO(name)
#    define XS_INTERNAL(name) STATIC XSPROTO(name)
#  endif
#  if defined(__SYMBIAN32__)
#    define XS_EXTERNAL(name) EXPORT_C XSPROTO(name)
#    define XS_INTERNAL(name) EXPORT_C STATIC XSPROTO(name)
#  endif
#  ifndef XS_EXTERNAL
#    if defined(HASATTRIBUTE_UNUSED) && !defined(__cplusplus)
#      define XS_EXTERNAL(name) void name(pTHX_ CV* cv __attribute__unused__)
#      define XS_INTERNAL(name) STATIC void name(pTHX_ CV* cv __attribute__unused__)
#    else
#      ifdef __cplusplus
#        define XS_EXTERNAL(name) extern "C" XSPROTO(name)
#        define XS_INTERNAL(name) static XSPROTO(name)
#      else
#        define XS_EXTERNAL(name) XSPROTO(name)
#        define XS_INTERNAL(name) STATIC XSPROTO(name)
#      endif
#    endif
#  endif
#endif

/* perl >= 5.10.0 && perl <= 5.15.1 */


/* The XS_EXTERNAL macro is used for functions that must not be static
 * like the boot XSUB of a module. If perl didn't have an XS_EXTERNAL
 * macro defined, the best we can do is assume XS is the same.
 * Dito for XS_INTERNAL.
 */
#ifndef XS_EXTERNAL
#  define XS_EXTERNAL(name) XS(name)
#endif
#ifndef XS_INTERNAL
#  define XS_INTERNAL(name) XS(name)
#endif

/* Now, finally, after all this mess, we want an ExtUtils::ParseXS
 * internal macro that we're free to redefine for varying linkage due
 * to the EXPORT_XSUB_SYMBOLS XS keyword. This is internal, use
 * XS_EXTERNAL(name) or XS_INTERNAL(name) in your code if you need to!
 */

#undef XS_EUPXS
#if defined(PERL_EUPXS_ALWAYS_EXPORT)
#  define XS_EUPXS(name) XS_EXTERNAL(name)
#else
   /* default to internal */
#  define XS_EUPXS(name) XS_INTERNAL(name)
#endif

#ifndef PERL_ARGS_ASSERT_CROAK_XS_USAGE
#define PERL_ARGS_ASSERT_CROAK_XS_USAGE assert(cv); assert(params)

/* prototype to pass -Wmissing-prototypes */
STATIC void
S_croak_xs_usage(pTHX_ const CV *const cv, const char *const params);

STATIC void
S_croak_xs_usage(pTHX_ const CV *const cv, const char *const params)
{
    const GV *const gv = CvGV(cv);

    PERL_ARGS_ASSERT_CROAK_XS_USAGE;

    if (gv) {
        const char *const gvname = GvNAME(gv);
        const HV *const stash = GvSTASH(gv);
        const char *const hvname = stash ? HvNAME(stash) : NULL;

        if (hvname)
            Perl_croak(aTHX_ "Usage: %s::%s(%s)", hvname, gvname, params);
        else
            Perl_croak(aTHX_ "Usage: %s(%s)", gvname, params);
    } else {
        /* Pants. I don't think that it should be possible to get here. */
        Perl_croak(aTHX_ "Usage: CODE(0x%"UVxf")(%s)", PTR2UV(cv), params);
    }
}
#undef  PERL_ARGS_ASSERT_CROAK_XS_USAGE

#ifdef PERL_IMPLICIT_CONTEXT
#define croak_xs_usage(a,b)    S_croak_xs_usage(aTHX_ a,b)
#else
#define croak_xs_usage        S_croak_xs_usage
#endif

#endif

/* NOTE: the prototype of newXSproto() is different in versions of perls,
 * so we define a portable version of newXSproto()
 */
#ifdef newXS_flags
#define newXSproto_portable(name, c_impl, file, proto) newXS_flags(name, c_impl, file, proto, 0)
#else
#define newXSproto_portable(name, c_impl, file, proto) (PL_Sv=(SV*)newXS(name, c_impl, file), sv_setpv(PL_Sv, proto), (CV*)PL_Sv)
#endif /* !defined(newXS_flags) */

#line 449 "Request.c"

XS_EUPXS(XS_Apache__Request_new); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Apache__Request_new)
{
    dVAR; dXSARGS;
    if (items < 2)
       croak_xs_usage(cv,  "class, r, ...");
    {
	SV *	class = ST(0)
;
	Apache	r;
#line 310 "Request.xs"
    int i;
    SV *robj;

#line 465 "Request.c"
	Apache__Request	RETVAL;

	r = sv2request_rec(ST(1), "Apache", cv)
;
#line 314 "Request.xs"
    class = class; /* -Wall */ 
    robj = ST(1);
    RETVAL = ApacheRequest_new(r);
    register_uploads(aTHX_ RETVAL);

    for (i=2; i<items; i+=2) {
        char *key = SvPV(ST(i),na);

        switch (toLOWER(*key)) {
          case 'd':
            if (strcaseEQ(key, "disable_uploads")) {
                RETVAL->disable_uploads = (int)SvIV(ST(i+1));
                break;
            }

          case 'h':
            if (strcaseEQ(key, "hook_data")) {
                XsUploadHookSet(data, ST(i+1));
                break;
            }

          case 'p':
            if (strcaseEQ(key, "post_max")) {
                RETVAL->post_max = (int)SvIV(ST(i+1));
                break;
            }

          case 't':
            if (strcaseEQ(key, "temp_dir")) {
                RETVAL->temp_dir = ap_pstrdup(r->pool,SvPV(ST(i+1), PL_na));
                break;
            }

          case 'u':
            if (strcaseEQ(key, "upload_hook")) {
                XsUploadHookSet(sub, ST(i+1));
                RETVAL->upload_hook = upload_hook;
                break;
            }

          default:
            croak("[libapreq] unknown attribute: `%s'", key);
        }
    }

#line 516 "Request.c"
	ST(0) = sv_newmortal();
	sv_setref_pv(ST(0), "Apache::Request", (void*)RETVAL);
#line 363 "Request.xs"
    apreq_add_magic(aTHX_ ST(0), robj, RETVAL);
#line 521 "Request.c"
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Apache__Request_script_name); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Apache__Request_script_name)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "req");
    {
	Apache__Request	req;
	char *	RETVAL;
	dXSTARG;

	req = sv_2apreq(aTHX_ ST(0))
;

	RETVAL = ApacheRequest_script_name(req);
	sv_setpv(TARG, RETVAL); XSprePUSH; PUSHTARG;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Apache__Request_parse); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Apache__Request_parse)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "req");
    {
	Apache__Request	req;
	int	RETVAL;
	dXSTARG;

	req = sv_2apreq(aTHX_ ST(0))
;

	RETVAL = ApacheRequest_parse(req);
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Apache__Request_query_params); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Apache__Request_query_params)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "req");
    {
	Apache__Request	req;
#line 379 "Request.xs"
    table *parms;

#line 580 "Request.c"
	Apache__Table	RETVAL;

	req = sv_2apreq(aTHX_ ST(0))
;
#line 382 "Request.xs"
    parms = ApacheRequest_query_params(req, req->r->pool);
    ST(0) = mod_perl_tie_table(parms);
#line 588 "Request.c"
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Apache__Request_post_params); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Apache__Request_post_params)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "req");
    {
	Apache__Request	req;
#line 390 "Request.xs"
    table *parms;

#line 605 "Request.c"
	Apache__Table	RETVAL;

	req = sv_2apreq(aTHX_ ST(0))
;
#line 393 "Request.xs"
    parms = ApacheRequest_post_params(req, req->r->pool);
    ST(0) = mod_perl_tie_table(parms);
#line 613 "Request.c"
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Apache__Request_parms); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Apache__Request_parms)
{
    dVAR; dXSARGS;
    if (items < 1 || items > 2)
       croak_xs_usage(cv,  "req, parms=NULL");
    {
	Apache__Request	req;
	Apache__Table	parms;

	req = sv_2apreq(aTHX_ ST(0))
;

	if (items < 2)
	    parms = NULL;
	else {
	    parms = (Apache__Table)hvrv2table(ST(1))
;
	}
#line 403 "Request.xs"
    if (parms) {
        req->parms = parms->utable;
        req->parsed = 1;
    }
    else {
        ApacheRequest_parse(req);
    }
    ST(0) = mod_perl_tie_table(req->parms);
#line 647 "Request.c"
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Apache__Request_param); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Apache__Request_param)
{
    dVAR; dXSARGS;
    if (items < 1 || items > 3)
       croak_xs_usage(cv,  "req, key=NULL, sv=Nullsv");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	Apache__Request	req;
	char *	key;
	SV *	sv;

	req = sv_2apreq(aTHX_ ST(0))
;

	if (items < 2)
	    key = NULL;
	else {
	    key = (char *)SvPV_nolen(ST(1))
;
	}

	if (items < 3)
	    sv = Nullsv;
	else {
	    sv = ST(2)
;
	}
#line 419 "Request.xs"
    if ( !req->parsed ) ApacheRequest_parse(req);

    if (key) {

	if (sv != Nullsv) {

	    if (SvROK(sv) && SvTYPE(SvRV(sv)) == SVt_PVAV) {
	    	I32 i;
	    	AV *av = (AV*)SvRV(sv);
	    	const char *val;

            	ap_table_unset(req->parms, key);
	    	for (i=0; i<=AvFILL(av); i++) {
		    val = (const char *)SvPV(*av_fetch(av, i, FALSE),PL_na);
	            ap_table_add(req->parms, key, val);
	    	}
	    }
            else ap_table_set(req->parms, key, (const char *)SvPV(sv, PL_na));
	}

	switch (GIMME_V) {

        case G_SCALAR:			/* return (first) parameter value */
	    {
	    	const char *val = ap_table_get(req->parms, key);
	    	if (val) XPUSHs(sv_2mortal(newSVpv((char*)val,0)));
	    	else XSRETURN_UNDEF;
	    }
	    break;

	case G_ARRAY:			/* return list of parameter values */
	    {
  	        I32 i;
	        array_header *arr  = ap_table_elts(req->parms);
	        table_entry *elts = (table_entry *)arr->elts;
	        for (i = 0; i < arr->nelts; ++i) {
	            if (elts[i].key && strcaseEQ(elts[i].key, key))
	            	XPUSHs(sv_2mortal(newSVpv(elts[i].val,0)));
	        }
	    }
	    break;

	default:
            XSRETURN_UNDEF;
	} 
    } 
    else {		

	switch (GIMME_V) {

	case G_SCALAR:	    		/* like $apr->parms */
	    ST(0) = mod_perl_tie_table(req->parms);
	    XSRETURN(1); 
	    break;

	case G_ARRAY:			/* return list of unique keys */
            {
            	I32 i;
	    	array_header *arr  = ap_table_elts(req->parms);
	    	table_entry *elts = (table_entry *)arr->elts;
	    	for (i = 0; i < arr->nelts; ++i) {
		    I32 j;
	           if (!elts[i].key) continue;
		    /* simple but inefficient uniqueness check */
		    for (j = 0; j < i; ++j) { 
		        if (strcaseEQ(elts[i].key, elts[j].key))
			    break;
		    }
	            if ( i == j )
	                XPUSHs(sv_2mortal(newSVpv(elts[i].key,0)));
	        }
            }
	    break;

	default:
	    XSRETURN_UNDEF;
 	}
    }
#line 761 "Request.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Apache__Request_upload); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Apache__Request_upload)
{
    dVAR; dXSARGS;
    if (items < 1 || items > 2)
       croak_xs_usage(cv,  "req, sv=Nullsv");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	Apache__Request	req;
	SV *	sv;
#line 504 "Request.xs"
    ApacheUpload *uptr;

#line 782 "Request.c"

	req = sv_2apreq(aTHX_ ST(0))
;

	if (items < 2)
	    sv = Nullsv;
	else {
	    sv = ST(1)
;
	}
#line 507 "Request.xs"
    if (sv && SvOBJECT(sv) && sv_isa(sv, "Apache::Upload")) {
        req->upload = (ApacheUpload *)SvIV((SV*)SvRV(sv));
        XSRETURN_EMPTY;
    }

    if ( !req->parsed ) ApacheRequest_parse(req);

    if (GIMME == G_SCALAR) {
        STRLEN n_a;
        char *name = sv ? SvPV(sv, n_a) : NULL;

	if (name) {
	    uptr = ApacheUpload_find(req->upload, name);
	}
	else {
	    uptr = req->upload;
	}

	if (!uptr)
            XSRETURN_UNDEF;

	upload_push(aTHX_ uptr);
    }
    else {
	for (uptr = req->upload; uptr; uptr = uptr->next)
	    upload_push(aTHX_ uptr);
    }
#line 821 "Request.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Apache__Request_expires); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Apache__Request_expires)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "req, time_str");
    {
	Apache__Request	req;
	char *	time_str = (char *)SvPV_nolen(ST(1))
;
	char *	RETVAL;
	dXSTARG;

	req = sv_2apreq(aTHX_ ST(0))
;

	RETVAL = ApacheRequest_expires(req, time_str);
	sv_setpv(TARG, RETVAL); XSprePUSH; PUSHTARG;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Apache__Upload_fh); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Apache__Upload_fh)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "upload");
    {
	Apache__Upload	upload;
#line 549 "Request.xs"
    int fd;
    FILE *fp;

#line 863 "Request.c"
	ApreqInputStream	RETVAL;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "Apache::Upload")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    upload = INT2PTR(Apache__Upload,tmp);
	}
	else
	    Perl_croak(aTHX_ "%s: %s is not of type %s",
			"Apache::Upload::fh",
			"upload", "Apache::Upload")
;
#line 553 "Request.xs"
    fp = ApacheUpload_fh(upload);
    if (fp == NULL)
        XSRETURN_UNDEF;
#if PERL_REVISION == 5 && PERL_VERSION > 7
    fd = PerlLIO_dup(fileno(fp));
    /* XXX: user should check errno on undef returns */

    if (fd < 0) 
        XSRETURN_UNDEF;

    if ( !(RETVAL = PerlIO_fdopen(fd, "rb")) )
	XSRETURN_UNDEF;
#else
    if (  ( RETVAL = PerlIO_importFILE(fp,0) ) == NULL  )
	    XSRETURN_UNDEF;
#endif

#line 893 "Request.c"
	ST(0) = sv_newmortal();
        {
            GV *gv = newGVgen("Apache::Upload");
            if ( do_open(gv, "<&", 2, FALSE, 0, 0, RETVAL) )
                sv_setsv(ST(0), sv_bless(newRV_noinc((SV*)gv),
                                        gv_stashpv("Apache::Upload",1)));
            else
                ST(0) = &PL_sv_undef;
            (void)hv_delete(GvSTASH(gv), GvNAME(gv), GvNAMELEN(gv), G_DISCARD);
        }
#line 574 "Request.xs"
    /* XXX: there may be a leak/segfault in here somewhere */
#if PERL_REVISION == 5 && PERL_VERSION > 7
    if (ST(0) != &PL_sv_undef) {
        IO *io = GvIOn((GV*)SvRV(ST(0)));
        if (upload->req->parsed)
            PerlIO_seek(IoIFP(io), 0, 0);
    }
#else
    if (ST(0) != &PL_sv_undef) {
        IO *io = GvIOn((GV*)SvRV(ST(0)));
        int fd = PerlIO_fileno(IoIFP(io));
        PerlIO *fp;

        fd = PerlLIO_dup(fd);
        if (!(fp = PerlIO_fdopen(fd, "rb"))) { 
            PerlLIO_close(fd);
            croak("fdopen failed!");
        }
        if (upload->req->parsed)
            PerlIO_seek(fp, 0, 0);

        IoIFP(io) = fp;  	
    }
#endif
#line 929 "Request.c"
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Apache__Upload_size); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Apache__Upload_size)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "upload");
    {
	Apache__Upload	upload;
	long	RETVAL;
	dXSTARG;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "Apache::Upload")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    upload = INT2PTR(Apache__Upload,tmp);
	}
	else
	    Perl_croak(aTHX_ "%s: %s is not of type %s",
			"Apache::Upload::size",
			"upload", "Apache::Upload")
;

	RETVAL = ApacheUpload_size(upload);
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Apache__Upload_name); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Apache__Upload_name)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "upload");
    {
	Apache__Upload	upload;
	char *	RETVAL;
	dXSTARG;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "Apache::Upload")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    upload = INT2PTR(Apache__Upload,tmp);
	}
	else
	    Perl_croak(aTHX_ "%s: %s is not of type %s",
			"Apache::Upload::name",
			"upload", "Apache::Upload")
;

	RETVAL = ApacheUpload_name(upload);
	sv_setpv(TARG, RETVAL); XSprePUSH; PUSHTARG;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Apache__Upload_filename); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Apache__Upload_filename)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "upload");
    {
	Apache__Upload	upload;
	char *	RETVAL;
	dXSTARG;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "Apache::Upload")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    upload = INT2PTR(Apache__Upload,tmp);
	}
	else
	    Perl_croak(aTHX_ "%s: %s is not of type %s",
			"Apache::Upload::filename",
			"upload", "Apache::Upload")
;

	RETVAL = ApacheUpload_filename(upload);
	sv_setpv(TARG, RETVAL); XSprePUSH; PUSHTARG;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Apache__Upload_tempname); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Apache__Upload_tempname)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "upload");
    {
	Apache__Upload	upload;
	char *	RETVAL;
	dXSTARG;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "Apache::Upload")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    upload = INT2PTR(Apache__Upload,tmp);
	}
	else
	    Perl_croak(aTHX_ "%s: %s is not of type %s",
			"Apache::Upload::tempname",
			"upload", "Apache::Upload")
;

	RETVAL = ApacheUpload_tempname(upload);
	sv_setpv(TARG, RETVAL); XSprePUSH; PUSHTARG;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Apache__Upload_next); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Apache__Upload_next)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "upload");
    {
	Apache__Upload	upload;
	Apache__Upload	RETVAL;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "Apache::Upload")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    upload = INT2PTR(Apache__Upload,tmp);
	}
	else
	    Perl_croak(aTHX_ "%s: %s is not of type %s",
			"Apache::Upload::next",
			"upload", "Apache::Upload")
;

	RETVAL = ApacheUpload_next(upload);
	ST(0) = sv_newmortal();
	sv_setref_pv(ST(0), "Apache::Upload", (void*)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Apache__Upload_type); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Apache__Upload_type)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "upload");
    {
	Apache__Upload	upload;
	const char *	RETVAL;
	dXSTARG;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "Apache::Upload")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    upload = INT2PTR(Apache__Upload,tmp);
	}
	else
	    Perl_croak(aTHX_ "%s: %s is not of type %s",
			"Apache::Upload::type",
			"upload", "Apache::Upload")
;

	RETVAL = ApacheUpload_type(upload);
	sv_setpv(TARG, RETVAL); XSprePUSH; PUSHTARG;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Apache__Upload_link); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Apache__Upload_link)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "upload, name");
    {
	Apache__Upload	upload;
	char *	name = (char *)SvPV_nolen(ST(1))
;
	char *	RETVAL;
	dXSTARG;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "Apache::Upload")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    upload = INT2PTR(Apache__Upload,tmp);
	}
	else
	    Perl_croak(aTHX_ "%s: %s is not of type %s",
			"Apache::Upload::link",
			"upload", "Apache::Upload")
;
#line 629 "Request.xs"
	RETVAL = (link(upload->tempname, name)) ? NULL : name;

#line 1128 "Request.c"
	sv_setpv(TARG, RETVAL); XSprePUSH; PUSHTARG;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Apache__Upload_info); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Apache__Upload_info)
{
    dVAR; dXSARGS;
    if (items < 1 || items > 2)
       croak_xs_usage(cv,  "upload, key=NULL");
    {
	Apache__Upload	upload;
	char *	key;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "Apache::Upload")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    upload = INT2PTR(Apache__Upload,tmp);
	}
	else
	    Perl_croak(aTHX_ "%s: %s is not of type %s",
			"Apache::Upload::info",
			"upload", "Apache::Upload")
;

	if (items < 2)
	    key = NULL;
	else {
	    key = (char *)SvPV_nolen(ST(1))
;
	}
#line 640 "Request.xs"
    if (key) {
	const char *val = ApacheUpload_info(upload, key);
	if (!val)
	    XSRETURN_UNDEF;

	ST(0) = sv_2mortal(newSVpv((char *)val,0));
    }   
    else {
        ST(0) = mod_perl_tie_table(upload->info);
    }
#line 1172 "Request.c"
    }
    XSRETURN(1);
}

#ifdef __cplusplus
extern "C"
#endif
XS_EXTERNAL(boot_Apache__Request); /* prototype to pass -Wmissing-prototypes */
XS_EXTERNAL(boot_Apache__Request)
{
    dVAR; dXSARGS;
#if (PERL_REVISION == 5 && PERL_VERSION < 9)
    char* file = __FILE__;
#else
    const char* file = __FILE__;
#endif

    PERL_UNUSED_VAR(cv); /* -W */
    PERL_UNUSED_VAR(items); /* -W */
#ifdef XS_APIVERSION_BOOTCHECK
    XS_APIVERSION_BOOTCHECK;
#endif
    XS_VERSION_BOOTCHECK;

        newXS("Apache::Request::new", XS_Apache__Request_new, file);
        newXS("Apache::Request::script_name", XS_Apache__Request_script_name, file);
        newXS("Apache::Request::parse", XS_Apache__Request_parse, file);
        newXS("Apache::Request::query_params", XS_Apache__Request_query_params, file);
        newXS("Apache::Request::post_params", XS_Apache__Request_post_params, file);
        newXS("Apache::Request::parms", XS_Apache__Request_parms, file);
        newXS("Apache::Request::param", XS_Apache__Request_param, file);
        newXS("Apache::Request::upload", XS_Apache__Request_upload, file);
        newXS("Apache::Request::expires", XS_Apache__Request_expires, file);
        newXS("Apache::Upload::fh", XS_Apache__Upload_fh, file);
        newXS("Apache::Upload::size", XS_Apache__Upload_size, file);
        newXS("Apache::Upload::name", XS_Apache__Upload_name, file);
        newXS("Apache::Upload::filename", XS_Apache__Upload_filename, file);
        newXS("Apache::Upload::tempname", XS_Apache__Upload_tempname, file);
        newXS("Apache::Upload::next", XS_Apache__Upload_next, file);
        newXS("Apache::Upload::type", XS_Apache__Upload_type, file);
        newXS("Apache::Upload::link", XS_Apache__Upload_link, file);
        newXS("Apache::Upload::info", XS_Apache__Upload_info, file);

    /* Initialisation Section */

#line 302 "Request.xs"
    av_push(perl_get_av("Apache::Request::ISA",TRUE), newSVpv("Apache",6));

#line 1221 "Request.c"

    /* End of Initialisation Section */

#if (PERL_REVISION == 5 && PERL_VERSION >= 9)
  if (PL_unitcheckav)
       call_list(PL_scopestack_ix, PL_unitcheckav);
#endif
    XSRETURN_YES;
}

